// ><(((*> <(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*>
//
//          streamCapture2
//          (C) Copyright  2016 - 2024 Ingemar Ceicer
//          https://gitlab.com/posktomten/streamcapture2/
//          programming@ceicer.com
//
//   This program is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
// ><(((*> <(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*>

#include <QFontMetrics>
#include "newprg.h"
//#include "qforeach.h"
#include "ui_newprg.h"

/* SOK */

void Newprg::sok()
{
    ui->comboBox->clear();
    QTimer *timer = new QTimer(this);
    connect(timer, &QTimer::timeout, [this]() {
        if(ui->progressBar->value() >= 100) {
            ui->progressBar->setValue(0);
        }

        ui->progressBar->setValue(ui->progressBar->value() + 1);
    });
    timer->start(100);

    // QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME, EXECUTABLE_NAME);
    // settings.beginGroup("Path");
    // svtplaydl = settings.value("svtplayPath").toString();
    // settings.endGroup();
    //  QStringList *combo = new QStringList;
    // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);

    if(!fileExists(svtplaydl)) {
        /*   */
        QSettings settings2(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME,
                            LIBRARY_NAME);
        settings2.beginGroup("Path");
        QString stablepath = settings2.value("stablepath").toString();
        settings2.endGroup();
#ifdef Q_OS_LINUX
        svtplaydl = stablepath + "/stable/svtplay-dl";
#endif
#ifdef Q_OS_WINDOWS
        svtplaydl = stablepath + "/stable/svtplay-dl.exe";
#endif

        /*   */

        if(!fileExists(svtplaydl)) {
//        // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
            // ui->teOut->setTextColor(QColor("red"));
            ui->teOut->setText(svtplaydl +
                               tr(" cannot be found or is not an executable program."));
            ui->teOut->append(tr("Please click on \"Tools\" and select svtplay-dl."));
            // ui->teOut->setTextColor(QColor(txtcolor));
            timer->stop();
            ui->progressBar->setValue(0);
            return;
        }
    }

//    ui->teOut->setTabStopDistance(115);
    // ip
//    QFont font = ui->teOut->font();
//    QFontMetrics metrics(font);
//    ipac
//    int vidd = metrics.horizontalAdvance(" ");
//    ui->teOut->setTabStopDistance(vidd * TABSTOPWIDTH);
    ui->teOut->append(tr("The information from svtplay-dl may or may not contain:"));
    ui->teOut->append(tr("Quality, Method, Codec, Resolution, Language and Role") + "\n");
//    ui->teOut->append(tr("Quality") + "\t" + tr("Method") + "\t" + tr("Codec") + "\t" + tr("Resolution") + "\t" + tr("Language") + "\t" + tr("Role"));
    QStringList ARG;
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME, EXECUTABLE_NAME);
    // settings.setIniCodec("UTF-8");
    settings.beginGroup("Stcookies");
    QString stcookie = settings.value("stcookie", "").toString();
    settings.endGroup();

    if(ui->leSok->text().contains("https://www.tv4play.se")) {
        settings.beginGroup("Stcookies");
        QString tv4token = settings.value("tv4token", "").toString();
        settings.endGroup();

        if(!tv4token.isEmpty()) {
            ARG << "--token" << tv4token;
        } else {
            QMessageBox msgBox1;
            msgBox1.setIcon(QMessageBox::Critical);
            msgBox1.setWindowTitle(DISPLAY_NAME " " VERSION);
            msgBox1.setText(tr("You need to download the TV4 token from your browser and save it in streamCapture2."));
            msgBox1.addButton(tr("Ok"), QMessageBox::AcceptRole);
            msgBox1.exec();
            timer->stop();
            ui->progressBar->setValue(0);
            return;
        }
    }

    settings.beginGroup("Settings");
    bool try4k = settings.value("try4k", false).toBool();
    settings.endGroup();

    if(try4k) {
        ARG << "--format" << "dvhevc-51,dvhevc,hevc-51,hevc";
    }

    if(!stcookie.isEmpty()) {
        ARG << "--cookies"  << "st=" + stcookie;
    }

    // ui->teOut->setTextColor(txtcolor);
    ui->pbSok->setEnabled(false);
    ui->actionSearch->setEnabled(false);
    ui->actionListAllEpisodes->setEnabled(false);
    QTimer::singleShot(2000, this, [this] {
        ui->pbSok->setEnabled(true);
        ui->actionSearch->setEnabled(true);
        ui->actionListAllEpisodes->setEnabled(true);
    });
    ui->teOut->setReadOnly(true);
    QString sok = ui->leSok->text();
    sok = sok.simplified();

    if(sok.isEmpty()) {
        ui->teOut->setText(tr("The search field is empty!"));
        timer->stop();
        ui->progressBar->setValue(0);
        ui->leQuality->setText(QLatin1String(""));
        ui->leMethod->setText(QLatin1String(""));
    } else if((sok.left(7) != QStringLiteral("http://")) && (sok.left(8) != QStringLiteral(u"https://"))) {
        ui->teOut->setText(tr("Incorrect URL"));
        ui->leQuality->setText(QLatin1String(""));
        ui->leMethod->setText(QLatin1String(""));
        timer->stop();
        ui->progressBar->setValue(0);
    } else {
        address = ui->leSok->text().trimmed();
        int questionmark = address.indexOf('?');
        address = address.left(questionmark);
        // Hit

        if(ui->comboPayTV->currentIndex() == 0) {  // No Password
            ARG << "--list-quality" << address;
        } else { // Password
            QString provider = ui->comboPayTV->currentText();
            settings.beginGroup("Provider");
            QString username = settings.value(provider + "/username").toString();
            QString password = settings.value(provider + "/password").toString();
            settings.endGroup();

            if(password.isEmpty()) {
                password = secretpassword;

                if(password == "") {
                    bool ok;
                    QString newpassword = QInputDialog::getText(
                                              nullptr, provider + " " + tr("Enter your password"),
                                              tr("Spaces are not allowed. Use only the characters your "
                                                 "streaming provider approves.\nThe Password will not be "
                                                 "saved."),
                                              QLineEdit::Password, QLatin1String(""), &ok);

                    if(newpassword.indexOf(' ') >= 0) {
                        timer->stop();
                        ui->progressBar->setValue(0);
                        return;
                    }

                    if(ok) {
                        secretpassword = newpassword;
                        password = newpassword;
                    }
                }
            }

// tesstsearch
//            QString test = doTestSearch(address, username, password);
//            if(test.trimmed() != "") {
//                ui->teOut->setText(test);
//                return;
//            }
            ARG << "--list-quality" << "--username" << username << "--password" << password << address;
        }

        CommProcess2 = new QProcess(nullptr);
        CommProcess2->setProcessChannelMode(QProcess::MergedChannels);
        CommProcess2->start(svtplaydl, ARG);
        processpid = CommProcess2->processId();
//        connect(CommProcess2, SIGNAL(finished(int, QProcess::ExitStatus)), this,
//                SLOT(onCommProcessExit_sok(int, QProcess::ExitStatus)));
        connect(CommProcess2, QOverload<int, QProcess::ExitStatus>::of(&QProcess::finished),
                this, &Newprg::onCommProcessExit_sok);
        connect(CommProcess2, &QProcess::readyReadStandardOutput, [this, timer]() {
            QString result(CommProcess2->readAllStandardOutput());

            if(ui->actionShowMore->isChecked()) {
                // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                // ui->teOut->setTextColor(QColor("purple"));
                ui->teOut->append(result);
                // ui->teOut->setTextColor(QColor(txtcolor));
            }

            // else {
            //     qDebug() << "PROGRESS";
            // }

            if(result.mid(0, 25) == QStringLiteral("ERROR: svtplay-dl crashed")) {
                // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                // ui->teOut->setTextColor(QColor("red"));
                ui->teOut->append(svtplaydl + tr(" crashed."));
                ui->teOut->append(
                    tr("Can not find any video streams, please check the address."));
                timer->stop();
                ui->progressBar->setValue(0);
                // ui->teOut->setTextColor(QColor(txtcolor));
                return;
            }

            if(result.contains(QStringLiteral("ERROR: No videos found. You need to login"))) {
                // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                // ui->teOut->setTextColor(QColor("red"));
                ui->teOut->append(tr("Unable to log in. Forgot your username and password?"));
                // ui->teOut->setTextColor(QColor(txtcolor));
                timer->stop();
                ui->progressBar->setValue(0);
                return;
            }

            if(result.contains(QStringLiteral("ERROR: No videos found. You need a token to access the website. see https://svtplay-dl.se/tv4play/"))) {
                // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                // ui->teOut->setTextColor(QColor("red"));
                ui->teOut->append(tr("ERROR: No videos found. You need a token to access the website. see https://svtplay-dl.se/tv4play/"));
                // ui->teOut->setTextColor(QColor(txtcolor));
                timer->stop();
                ui->progressBar->setValue(0);
                return;
            }

            if(result.contains(QStringLiteral("ERROR: That site is not supported. Make a ticket or send a message"))) {
                // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                // ui->teOut->setTextColor(QColor("red"));
                ui->teOut->append(tr("ERROR: That site is not supported. Please visit https://github.com/spaam/svtplay-dl/issues"));
                // ui->teOut->setTextColor(QColor(txtcolor));
                timer->stop();
                ui->progressBar->setValue(0);
                return;
            }

            if(result.contains(QStringLiteral("ERROR: No videos found. This mode is not supported anymore. Need the url with the video."))) {
                // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                // ui->teOut->setTextColor(QColor("red"));
                ui->teOut->append(tr("ERROR: No videos found. This mode is not supported anymore. Need the url with the video."));
                // ui->teOut->setTextColor(QColor(txtcolor));
                timer->stop();
                ui->progressBar->setValue(0);
                return;
            }

            if(result.contains(QStringLiteral("ERROR: No videos found. We can't download DRM protected content from this site."))) {
                // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                // ui->teOut->setTextColor(QColor("red"));
                ui->teOut->append(tr("ERROR: No videos found. We can't download DRM protected content from this site."));
                // ui->teOut->setTextColor(QColor(txtcolor));
                timer->stop();
                ui->progressBar->setValue(0);
                return;
            }

            if(result.mid(0, 6) != QStringLiteral("ERROR:")) {
                ui->pbAdd->setEnabled(true);
                ui->actionAdd->setEnabled(true);
                ui->pbDownload->setEnabled(true);
                result = result.simplified();
                // 2021-07-07
                // Adaptation for 4.0-5-ga162357

                if(result.contains("{'url':")) {
                    result.clear();
                }

                QStringList list = result.split(QStringLiteral("INFO:"));
                list.removeDuplicates();

                for(auto& str : list)
                    str = str.trimmed();

                list.removeAll("");

                for(auto &s : list) {
                    if(s.contains("Quality:")) {
                        continue;
                    }

//                    int tabdistans = ui->teOut->tabStopDistance();
//                    ui->teOut->setTabStopDistance(115);
                    s.replace(' ', '\t');
                    QStringList newList = s.split('\t');
                    QString ut;

                    for(QString &ones :  newList) {
                        ut.append(ones + "  ");
                    }

                    ui->teOut->append(ut);
                    ut.clear();
//                    ui->teOut->append(s);
//                    ui->teOut->append(s);
                    int hittat = s.indexOf('\t');
                    hittat = s.indexOf('\t', hittat + 1);
                    s.replace('\t', ' ');
//                    for(int index = 0; index < ui->comboBox->count(); index++) {
//                        if(s.mid(0, hittat) == ui->comboBox->itemText(index)) {
//                            break;
//                        }
                    ui->comboBox->addItem(s.mid(0, hittat));
//                    }
//                    for(QString s : qAsConst(list)) {
//                        ui->teOut->append(s);
//                    }
                    ui->comboAmount->clear();
                    ui->comboAmount->addItem("- " + tr("Deviation"));

                    for(int i = 0; i <= 10; i++) {
                        ui->comboAmount->addItem(QString::number(i * 100));
                    }

                    ui->comboAmount->setCurrentIndex(0);
                    ui->comboResolution->setEnabled(true);
                }
            } else {
                if(result.contains(QStringLiteral("ERROR: No videos found. Cant find video id for the video"))) {
                    QString notfind = tr("ERROR: No videos found. Can't find video id for the video.");
                    // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                    // ui->teOut->setTextColor(QColor("red"));
                    timer->stop();
                    ui->progressBar->setValue(0);
                    ui->teOut->append(notfind);
                    // ui->teOut->setTextColor(QColor(txtcolor));
                } else if(result.contains(QStringLiteral("ERROR: No videos found. Can't find video id for the video"))) {
                    QString notfind = tr("ERROR: No videos found. Can't find video id for the video.");
                    // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                    // ui->teOut->setTextColor(QColor("red"));
                    timer->stop();
                    ui->progressBar->setValue(0);
                    ui->teOut->append(notfind);
                    // ui->teOut->setTextColor(QColor(txtcolor));
                } else if(result.contains(QStringLiteral("ERROR: No videos found. Can't find video id"))) {
                    QString notfind = tr("ERROR: No videos found. Can't find video id.");
                    // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                    // ui->teOut->setTextColor(QColor("red"));
                    timer->stop();
                    ui->progressBar->setValue(0);
                    ui->teOut->append(notfind);
                    // ui->teOut->setTextColor(QColor(txtcolor));
                } else if(result.contains(QStringLiteral("ERROR: No videos found. Can't decode api request:"))) {
                    QString notfind = tr("ERROR: No videos found. Can't decode api request.");
                    // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                    // ui->teOut->setTextColor(QColor("red"));
                    timer->stop();
                    ui->progressBar->setValue(0);
                    ui->teOut->append(notfind);
                    // ui->teOut->setTextColor(QColor(txtcolor));
                } else if(result.contains(QStringLiteral("ERROR: No videos found. Use the video page not the series page"))) {
                    QString notfind = tr("ERROR: No videos found. Use the video page not the series page.");
                    // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                    // ui->teOut->setTextColor(QColor("red"));
                    timer->stop();
                    ui->progressBar->setValue(0);
                    ui->teOut->append(notfind);
                    // ui->teOut->setTextColor(QColor(txtcolor));
                } else if(result.contains(QStringLiteral("ERROR: No videos found. Can't find any videos. Is it removed?"))) {
                    QString notfind = tr("ERROR: No videos found. Can't find any videos. Is it removed?");
                    // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                    // ui->teOut->setTextColor(QColor("red"));
                    timer->stop();
                    ui->progressBar->setValue(0);
                    ui->teOut->append(notfind);
                    // ui->teOut->setTextColor(QColor(txtcolor));
                } else if(result.contains(QStringLiteral("ERROR: No videos found. Can't find the video file"))) {
                    QString notfind = tr("ERROR: No videos found. Can't find the video file.");
                    // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                    // ui->teOut->setTextColor(QColor("red"));
                    timer->stop();
                    ui->progressBar->setValue(0);
                    ui->teOut->append(notfind);
                    // ui->teOut->setTextColor(QColor(txtcolor));
                    // } else if(result.contains(QStringLiteral("ERROR: Can't find any videos."))) {
                    //     QString notfind = tr("ERROR: Can't find any videos.");
                    //     // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                    //     // ui->teOut->setTextColor(QColor("red"));
                    //     ui->teOut->append(notfind);
                    // ui->teOut->setTextColor(QColor(txtcolor));
                } else if(result.contains(QStringLiteral("ERROR: Can't find any videos."))) {
                    QString notfind = tr("ERROR: Can't find any videos.");
                    // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                    // ui->teOut->setTextColor(QColor("red"));
                    timer->stop();
                    ui->progressBar->setValue(0);
                    ui->teOut->append(notfind);
                } else if(result.contains(QStringLiteral("WARNING: --all-episodes not implemented for this service"))) {
                    QString notfind = tr("WARNING: --all-episodes not implemented for this service.");
                    // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                    // ui->teOut->setTextColor(QColor("red"));
                    timer->stop();
                    ui->progressBar->setValue(0);
                    ui->teOut->append(notfind);
                }
                // ui->teOut->setTextColor(QColor(txtcolor));
                else if(result.contains(QStringLiteral("WARNING: Use program page instead of the clip / video page."))) {
                    QString notfind = tr("WARNING: Use program page instead of the clip / video page.");
                    // QString txtcolor = ui->teOut->textColor().name(QColor::HexRgb);
                    // ui->teOut->setTextColor(QColor("red"));
                    timer->stop();
                    ui->progressBar->setValue(0);
                    ui->teOut->append(notfind);
                    // ui->teOut->setTextColor(QColor(txtcolor));
                } else {
                    ui->teOut->append(result);
                }
            }

            timer->stop();
            ui->progressBar->setValue(0);
        });
    }
}

/* END SOK */
